#include "../../lib/libdefs.h"
#include "../../lib/mcrypt_modules.h"

/* EBC MODE */

#define _init_mcrypt ecb_LTX__init_mcrypt
#define _end_mcrypt ecb_LTX__end_mcrypt
#define _mcrypt ecb_LTX__mcrypt
#define _mdecrypt ecb_LTX__mdecrypt
#define _has_iv ecb_LTX__has_iv
#define _is_block_mode ecb_LTX__is_block_mode
#define _is_block_algorithm_mode ecb_LTX__is_block_algorithm_mode
#define _mcrypt_get_iv_size ecb_LTX__mcrypt_get_iv_size
#define _mcrypt_get_modes_name ecb_LTX__mcrypt_get_modes_name
#define _mcrypt_mode_get_size ecb_LTX__mcrypt_mode_get_size
#define _mcrypt_mode_version ecb_LTX__mcrypt_mode_version

int _init_mcrypt( int td, void* ign, void *key, int lenofkey, void *IV)
{
	return 0;

}

int _end_mcrypt (void* buf) {return 0;}

int _mcrypt(int td, void* ign, void *plaintext, int len)
{
	int j, blocksize;
	char *plain = plaintext;

	blocksize = __mcrypt_get_block_size(td);
	for (j = 0; j < len / blocksize; j++) {

		mcrypt_block_encrypt(td, &plain[j * blocksize]);

	}
	return 0;
}



int _mdecrypt(int td, void* ign, void *ciphertext, int len)
{
	int j, blocksize = __mcrypt_get_block_size(td);
	char *cipher = ciphertext;

	for (j = 0; j < len / blocksize; j++) {

		mcrypt_block_decrypt(td, &cipher[j * blocksize]);

	}

	return 0;
}

int _has_iv() { return 0; }
int _is_block_mode() { return 1; }
int _is_block_algorithm_mode() { return 1; }
int _mcrypt_get_iv_size(int td) { return mcrypt_get_block_size(td); }
char *_mcrypt_get_modes_name() { char*x; x=malloc(10); strcpy(x, "ECB"); return x;}
int _mcrypt_mode_get_size () {return 0;}

word32 _mcrypt_mode_version() {
	return 19991203;
}
